import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

String GAME_TITLE = "You Are The Level Designer!";

/*

Temporary platforms are kind of buggy. Don't always take the same amount of time, it seems.

tunneling is possible.

can currently put a block on an enemy

allow pressing a key to quit (think this works automatically)

*/

import java.awt.Rectangle;
 Minim minim;
 AudioPlayer victory, jump0, jump1, jump2, hitBreakable, destroy, death, coin, placeTile;
 boolean mute = false;
void setup() {
  size(960,640);
  bgBuffer = createGraphics(width,height);
  
  minim = new Minim(this);
  victory = minim.loadFile("victory.wav");
  jump0 = minim.loadFile("jump0.wav");
  jump1 = minim.loadFile("jump1.wav");
  jump2 = minim.loadFile("jump2.wav");
  hitBreakable = minim.loadFile("hitBreakable.wav");
  destroy = minim.loadFile("destroy.wav");
  death = minim.loadFile("death.wav");
  coin = minim.loadFile("coin.wav");
  placeTile = minim.loadFile("placeTile.wav");
  
  //frameRate(2);
  spring0 = loadImage("spring0.png");
  img1 = loadImage("1.png");
  img2 = loadImage("2.png");
  coinImg = loadImage("coin.png");
  enemyImg = loadImage("enemy.png");
  spikeImage = loadImage("spikes.png");
  startImage = loadImage("start.png");
  finishImage = loadImage("finish.png");
  jumperImage = loadImage("jumper.png");
  b10 = loadImage("b10.png");
  b8 = loadImage("b8.png");
  b6 = loadImage("b6.png");
  b4 = loadImage("b4.png");
  b2 = loadImage("b2.png");
  tntImg = loadImage("tnt.png");
  tempImg = loadImage("temp.png");
  
  loadLevel(currentLevel);
}


boolean levelMade = false;
boolean gameStarted = false;

PGraphics bgBuffer;
int TILE_SIZE = 32; //tile size in pixels
float GRAVITY_SCALAR = 0.015;
int gravityDirection = 1; //1 for down, -1 for up (because of pixel space)
int currentLevel = 0; //level number
float SPIKE_CUSHION = 0.25;
String[] tileMap;
Jumper jumper;
ArrayList<InteractiveObject> objects = new ArrayList<InteractiveObject>();
//tile types
char PLAYER_SPAWN = 'S';
char PLAYER_EXIT = 'E';
 //should make spring an interactive object
char WALL = '1';
char AIR = '0';
char DEATH = 'x'; //spikes?
//object types
char COIN = 'c';
float COIN_OFF_X = 0.1;
float COIN_OFF_Y = 0.1;
float COIN_SIZE = 0.8;
char SPRING = 'p';
char BREAKABLE = 'b';
char TEMPORARY = 't';
char ENEMY = 'e';
char WEAPON = 'w'; //not implemented..need bullet class, probably... maybe make a laser gun that can reflect and hurt the player :x

//player-related data...need to figure out UI at some point
char EXPLODE = 'X';
char SWAP = 's'; //not implemented, lets you swap one tile with an adjacent tile
char selectedResource = ' '; //stores tile that is being moved into play
int coins = 0;
int tileMouseX;
int tileMouseY;
HashMap<String,Integer> resources = new HashMap<String,Integer>();
/*
coin costs for resources:
2 = 1 coin;
1 = 2 coins;
b = 2 coins;
X = 2 coins;
t = 2 coins;
e = 3 coins;
p = 3 coins;
s = 4 coins;


*/

//images
PImage spring0, img2, coinImg, enemyImg, spikeImage, startImage, finishImage, jumperImage, img1, b10, b8, b6, b4, b2 ,tntImg, tempImg;

//tiles allowed in level... saved as string, index by level #
String[] levelResources = {"2", "p", "X", "1" ,"1", "tXX", "t", "11bttX" };


void stop()
{
  minim.stop() ;
  super.stop() ;
}

class InteractiveObject { //coins, enemies, interactive blocks, etc
  char type;
  boolean active = true;
  byte hp = 10;
  Rectangle hitbox;
  PImage graphic;
  int birthMillis;
  int DURATION = 3500;
  float ENEMY_BOOST = 0.1;
  InteractiveObject(char t, Rectangle h) {
    type = t;
    hitbox = h;
    birthMillis = millis();
  }
  void update(Jumper j) {
    if (active) {
      boolean playerCollision = false;
      PVector[] playerPoints = new PVector[5];
      playerPoints[0] = j.head;
      playerPoints[1] = j.leftHand;
      playerPoints[2] = j.rightHand;
      playerPoints[3] = j.leftFoot;
      playerPoints[4] = j.rightFoot;
      for (int i = 0; i < playerPoints.length; i++) {
        if (hitbox.contains(playerPoints[i].x, playerPoints[i].y)) {
          
          playerCollision = true;
        }
      }
      String oldString;
      switch (type) {
        case 'p': //spring
          if (playerCollision) {
            j.velocity.y = 0;
            j.jump(j.SPRING_BOOST);
          }
          break;
        case 'c': //coin
          if (playerCollision) {
            coins++;
            active = false;
            if (!mute) {
            coin.rewind();
            coin.play();
            }
          }
          break;
        case 'b': //breakable
          if (hitbox.contains(j.head.x, j.head.y)) {
            hp-=4;
            j.velocity.y = 0;
            j.knockDown();
            if (!mute) {
            hitBreakable.rewind();
            hitBreakable.play();
            }
          } else if (hitbox.contains(j.origin.x,j.origin.y)) {
            hp-=4;
            j.velocity.y =0;
            j.knockDown();
            if (!mute) {
            hitBreakable.rewind();
            hitBreakable.play();
            }
          }
          if (hp <= 0) {
              active = false;
              oldString = tileMap[hitbox.y];
              tileMap[hitbox.y] = oldString.substring(0,hitbox.x)+'0'+oldString.substring(hitbox.x+1);
              if (!mute) {
              destroy.rewind();
              destroy.play();
              }
            }
          break;
        case 't': //temporary
          if (birthMillis + DURATION <= millis()) {
            active = false;
            oldString = tileMap[hitbox.y];
            tileMap[hitbox.y] = oldString.substring(0,hitbox.x)+'0'+oldString.substring(hitbox.x+1);
          }
          break;
        case 'e': //enemy
          if (playerCollision) {
            if (hitbox.contains(j.rightFoot.x,j.rightFoot.y) || hitbox.contains(j.leftFoot.x,j.leftFoot.y)) {
              j.velocity.y = 0;
              j.jump(ENEMY_BOOST);
              active = false;
            } else if (hitbox.contains(j.rightHand.x,j.rightHand.y) || hitbox.contains(j.leftHand.x,j.leftHand.y) || hitbox.contains(j.head.x,j.head.y)) {
              if (!mute) {
              death.rewind();
              death.play();
              }
              loadLevel(currentLevel);
            }
          } else if (hitbox.y+1 < tileMap.length) {
            if (tileMap[hitbox.y+1].charAt(hitbox.x) == '0') {
              hitbox.y++;
            }
          }
          break;
        case 'w': //weapon
          break;
      }
    }
  }
  void paint() {
    if (active) {
      switch (type) {
        case 'p': //spring
         // fill(0, 255, 0, 255);
          //rect(hitbox.x*TILE_SIZE, (hitbox.y*TILE_SIZE)-5, TILE_SIZE, TILE_SIZE+5);
          image(spring0, hitbox.x*TILE_SIZE, (hitbox.y*TILE_SIZE)-5);
          break;
        case 'c': //coin
          /*stroke(0,0,0,0);
          fill(255,255,0,255);
          rect((hitbox.x+COIN_OFF_X)*TILE_SIZE,(hitbox.y+COIN_OFF_Y)*TILE_SIZE,COIN_SIZE*TILE_SIZE,COIN_SIZE*TILE_SIZE);*/
          image(coinImg, hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE);
          break;
        case 'b': //breakable
          /*stroke(0,0,0,0);
          fill(25*hp, 10*hp, 10*hp, 255);
          rect(hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE, TILE_SIZE, TILE_SIZE);*/
          switch (hp) {
            case 10:
              image(b10, hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE);
              break;
            case 8:
              image(b8, hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE);
              break;
            case 6:
              image(b6, hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE);
              break;
            case 4:
              image(b4, hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE);
              break;
            case 2:
              image(b2, hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE);
              break;
          }
          break;
        case 't': //temporary
          float perc = 1.0-(float(millis()-birthMillis)/DURATION);
          stroke(0,0,0,0);
          fill(255,255,255,255*perc);
          rect(hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE, TILE_SIZE, TILE_SIZE);
          break;
        case 'e': //enemy
          /*stroke(0,0,0,255);
          fill(255,0,50,255);
          rect(hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE, TILE_SIZE, TILE_SIZE);*/
          image(enemyImg, hitbox.x*TILE_SIZE, hitbox.y*TILE_SIZE);
          break;
        case 'w': //weapon
          break;
      }
    }
  }
}

class Jumper { //avatar that runs and jumps
  /*** orientation stuff ***/
  boolean FACING_RIGHT = true;
  boolean FACING_LEFT = false;
  boolean HEAD_UP = false; //for gravity flip
  boolean HEAD_DOWN = true;
  boolean xOrientation = FACING_LEFT;
  boolean yOrientation = HEAD_UP;
  /*** velocity ***/
  PVector velocity = new PVector(0,0);
  float MAX_VELOCITY_X = .9;
  float MAX_VELOCITY_Y = .9;
  int REFLECT_COOLDOWN = 250; //cooldown (ms) for turning around
  int lastReflect = -250;
  float REFLECT_BUMP = 0.1;
  float JUMP_VEL = 0.2;
  float WALL_JUMP_BONUS = 0.1;
  float SPRING_BOOST = 0.3;
  /** location(s) (tile space) ***/
  PVector origin;
  PVector leftHandOffset = new PVector(0.2,0.5);
  PVector rightHandOffset = new PVector(.8,0.5);
  PVector leftFootOffset = new PVector(0.2,1);
  PVector rightFootOffset = new PVector(.8,1);
  PVector headOffset = new PVector(0.5,0.25);
  PVector leftHand;
  PVector rightHand;
  PVector leftFoot;
  PVector rightFoot;
  PVector head;
  PVector spawn;
  /*** other qualities ***/
  boolean grounded = true;
  boolean alive = true;
  byte hp = 2;
  byte consecutiveWallJumps = 0;
  boolean moving = true;
  boolean armed = false;
  PImage graphic; //need to assign via loadImage
  boolean showPoints = false;
  Jumper(float ex, float why) {
    origin = new PVector(ex,why);
    spawn = new PVector(ex,why);
    leftHand = PVector.add(origin, leftHandOffset);
    rightHand = PVector.add(origin, rightHandOffset);
    leftFoot = PVector.add(origin, leftFootOffset);
    rightFoot = PVector.add(origin, rightFootOffset);
    head = PVector.add(origin,headOffset);
    velocity.x = 0.1;
    velocity.y = 0;
  }
  void knockDown() {
    origin.y = floor(origin.y)+1;
    leftHand = PVector.add(origin, leftHandOffset);
    rightHand = PVector.add(origin, rightHandOffset);
    leftFoot = PVector.add(origin, leftFootOffset);
    rightFoot = PVector.add(origin, rightFootOffset);
    head = PVector.add(origin,headOffset);
  }
  void jump(float bonus) {
    if (bonus == WALL_JUMP_BONUS) {
      consecutiveWallJumps++;
      if (consecutiveWallJumps > 1) {
        if (!mute) {
        jump2.rewind();
        jump2.play();
        }
      } else {
        if (!mute) {
        jump1.rewind();
        jump1.play();
        }
      }
    } else {
      consecutiveWallJumps = 0;
      if (!mute) {
      jump0.rewind();
      jump0.play();
      }
    }
    grounded = false;
    velocity.y -= (JUMP_VEL+bonus)*gravityDirection;
  }
  void update() {
    PVector propLoc = new PVector(origin.x,origin.y);
    if (!grounded) {
      
      velocity.y += GRAVITY_SCALAR*gravityDirection;
      if (velocity.y > 0 && velocity.y > MAX_VELOCITY_Y) {
        velocity.y = MAX_VELOCITY_Y;
      } else if (velocity.y < 0 && velocity.y < MAX_VELOCITY_Y*-1) {
        velocity.y = MAX_VELOCITY_Y*-1;
      }
    } else {
      velocity.y = 0;
    }
    //println(velocity.y + " " + grounded + origin.y);
    propLoc.x += velocity.x;
    propLoc.y += velocity.y;
    /*while (propLoc.y+1 > tileMap.length) {
      propLoc.y--;
      grounded = true;
    }*/

    PVector propLeftHandTileLoc = PVector.add(propLoc, leftHandOffset);
    char propLeftHandTile = tileMap[floor(propLeftHandTileLoc.y)].charAt(floor(propLeftHandTileLoc.x));
    PVector propRightHandTileLoc = PVector.add(propLoc, rightHandOffset);
    char propRightHandTile = tileMap[floor(propRightHandTileLoc.y)].charAt(floor(propRightHandTileLoc.x));
    PVector propLeftFootTileLoc = PVector.add(propLoc, leftFootOffset);
    char propLeftFootTile = tileMap[floor(propLeftFootTileLoc.y)].charAt(floor(propLeftFootTileLoc.x));
    PVector propRightFootTileLoc = PVector.add(propLoc, rightFootOffset);
    char propRightFootTile = tileMap[floor(propRightFootTileLoc.y)].charAt(floor(propRightFootTileLoc.x));
    PVector propHeadTileLoc = PVector.add(propLoc,headOffset);
    char propHeadTile = tileMap[floor(propHeadTileLoc.y)].charAt(floor(propHeadTileLoc.x));
    
    
    //collision detection and reaction
    
    //check for death!
    if (propHeadTile == 'x' || propRightFootTile == 'x' || propLeftFootTile == 'x') {
      if (!mute) {
      death.rewind();
      death.play();
      }
      loadLevel(currentLevel);
    }
    
    if (propLeftFootTile == 'E' || propRightFootTile == 'E' || propLeftHandTile == 'E' || propRightHandTile == 'E' || propHeadTile == 'E') {
      if (moving && !mute) {
        victory.rewind();
        victory.play();
      }
      moving = false;
    }
    
    if (grounded) {
      if (velocity.x > 0) { //moving right
        if (propRightHandTile == '1' || propRightHandTile == '2') { //turn around
          velocity.x *= -1;
          propLoc.x -= REFLECT_BUMP;
        } else if (propRightFootTile == '0') {
          jump(0);
        }
      } else { //moving left (or not at all)
        if (propLeftHandTile == '1' || propLeftHandTile == '2') { //turn around
          velocity.x *= -1;
          propLoc.x += REFLECT_BUMP;
        } else if (propLeftFootTile == '0') {
          jump(0);
        }
      }
    } else { //not grounded
      if (propHeadTile != '0') {
        //hit head!
        velocity.y = 0;
        propLoc.y += gravityDirection*REFLECT_BUMP*2;
      }
      if (velocity.x > 0) { //moving right
        if (propRightFootTile == '1' && propRightHandTile == '1') {
          //wall jump!!!
          velocity.x *= -1;
          propLoc.x -= REFLECT_BUMP;
          jump(WALL_JUMP_BONUS);
        } else if ( propRightFootTile == '2' && propRightHandTile != '0') { //hit unwalljumpable
          propLoc.x -= REFLECT_BUMP;
          velocity.x *= -1;
        } else if (propRightHandTile == '0') {
          if (propRightFootTile != '0' || propLeftFootTile != '0') {
            grounded = true;
          }
        }
      } else { //moving left (or not at all)
        if (propLeftFootTile == '1' && propLeftHandTile == '1') {
          //wall jump!!!
          velocity.x *= -1;
          propLoc.x += REFLECT_BUMP;
          jump(WALL_JUMP_BONUS);
        } else if (propLeftFootTile == '2' && propLeftHandTile != '0') {
          propLoc.x+=REFLECT_BUMP;
          velocity.x*= -1;
        } else if (propLeftHandTile == '0') {
          if (propRightFootTile != '0' || propLeftFootTile != '0') {
            grounded = true;
          }
        }
      }
    }
    
    if (grounded) { //not absolutely tunnel-proof...
      if (propLoc.y % 1.0 > 0) {
        propLoc.y = floor(propRightFootTileLoc.y-1);
      }
    }
    
    if (moving) {
      origin.x = propLoc.x;
      origin.y = propLoc.y;
    }

    leftHand = PVector.add(origin, leftHandOffset);
    rightHand = PVector.add(origin, rightHandOffset);
    leftFoot = PVector.add(origin, leftFootOffset);
    rightFoot = PVector.add(origin, rightFootOffset);
    head = PVector.add(origin,headOffset);
    //deal with interactive objects
    InteractiveObject[] objectArray = objects.toArray(new InteractiveObject[0]);
    for (int i = 0; i < objectArray.length; i++) {
      objectArray[i].update(jumper);
      objectArray[i].paint();
    }
    
  }
  void paint() {
     pushMatrix();
    image(jumperImage,origin.x*TILE_SIZE,origin.y*TILE_SIZE);
    
    if (showPoints) {
      fill(255,0,0);
      
      ellipse(leftHand.x*TILE_SIZE,leftHand.y*TILE_SIZE,5,5);
      ellipse(rightHand.x*TILE_SIZE,rightHand.y*TILE_SIZE,5,5);
      ellipse(leftFoot.x*TILE_SIZE,leftFoot.y*TILE_SIZE,5,5);
      ellipse(rightFoot.x*TILE_SIZE,rightFoot.y*TILE_SIZE,5,5);
      ellipse(head.x*TILE_SIZE,head.y*TILE_SIZE,5,5);
    }
    
    
    
    popMatrix();
  }
}

void loadLevel(int lvl) {
  background(25, 25, 25);
  selectedResource = ' ';
  resources = new HashMap<String,Integer>();
  resources.put("1", 0); //walljumpable
  resources.put("2", 0); //slippery, indestructible
  resources.put("p", 0); //spring
  resources.put("b", 0); //breakable
  resources.put("t", 0); //timed
  resources.put("e", 0); //enemy
  resources.put("X", 0); //explode/destroy
  resources.put("s", 0); //swap
  
  levelMade = false;
  String oldString;
  coins = 0;
  objects = new ArrayList<InteractiveObject>();
  if (lvl >= 0) {
    tileMap = loadStrings(lvl+".txt");
  } else {
    tileMap = loadStrings("testmap.txt");
  }
  bgBuffer.beginDraw();
  bgBuffer.background(0,0,0,0);
  for (int i = 0; i < tileMap.length; i++) {
    for (int j = 0; j < tileMap[i].length(); j++) {
      
      switch (tileMap[i].charAt(j)) {
        case 'e': //enemy
          //make air on background, instantiate temporary block and have it in tilemap
          
          oldString = tileMap[i];
          tileMap[i] = oldString.substring(0,j)+'0'+oldString.substring(j+1);
          objects.add(new InteractiveObject('e',new Rectangle(j,i,1,1)));
          break;
        case 't': //temporary tile
          //make air on background, instantiate temporary block and have it in tilemap
          
          oldString = tileMap[i];
          tileMap[i] = oldString.substring(0,j)+'1'+oldString.substring(j+1);
          objects.add(new InteractiveObject('t',new Rectangle(j,i,1,1)));
          break;
        case 'E': //player exit
         
          bgBuffer.image(finishImage,TILE_SIZE*j, TILE_SIZE*i);
          break;
        case 'b': //breakable
          //make air on background, instantiate interactive block and have it in tilemap
         
          oldString = tileMap[i];
          tileMap[i] = oldString.substring(0,j)+'1'+oldString.substring(j+1);
          objects.add(new InteractiveObject('b',new Rectangle(j,i,1,1)));
          break;
        case 'c': //coin
          //tileMap same as air, then instantiate item
         
          oldString = tileMap[i];
          tileMap[i] = oldString.substring(0,j)+'0'+oldString.substring(j+1);
          objects.add(new InteractiveObject('c',new Rectangle(j,i,1,1)));
          
          break;
        case 'p': //spring booster
          
          oldString = tileMap[i];
          tileMap[i] = oldString.substring(0,j)+'1'+oldString.substring(j+1);
          objects.add(new InteractiveObject('p',new Rectangle(j,i,1,1)));
          break;
        case 'x': //spike
          
          bgBuffer.image(spikeImage,TILE_SIZE*j, TILE_SIZE*i);
          break;
        case 'S': //player spawn
          
          bgBuffer.image(startImage,TILE_SIZE*j, TILE_SIZE*i);
          jumper = new Jumper(j,i);
          oldString = tileMap[i];
          tileMap[i] = oldString.substring(0,j)+'0'+oldString.substring(j+1);
          break;
        case '2': //indestructible, unwalljumpable
         
          bgBuffer.image(img2,TILE_SIZE*j, TILE_SIZE*i);
          break;
        case '1': //normal wall/floor
         
          bgBuffer.image(img1, TILE_SIZE*j, TILE_SIZE*i);
          break;
        case '0': //air
         
          break;
        default:
          //na
      }
      
    }
  }
  
  bgBuffer.endDraw();
  for (int k = 0; k < levelResources[currentLevel].length(); k++) {
    String _key = Character.toString(levelResources[currentLevel].charAt(k));
    int v = int(resources.get(_key));
    resources.put(_key,v+1);
  }
  levelMade = true;
}

void mousePressed() {
  if (mouseX > TILE_SIZE*tileMap[0].length()) {
    if (selectedResource == ' ') {
      if (mouseX >= width-300 && mouseX <= width-268) { //mouse is in icon column
        if (mouseY >= 60 && mouseY <= 92 && (resources.get("2") > 0 || coins >= 1)) {
          selectedResource = '2';
          if (resources.get("2") == 0) {
            resources.put("2",1);
            coins--;
          }
        }
        if (mouseY >= 100 && mouseY <= 132 && (resources.get("1") > 0 || coins >= 2)) {
          selectedResource = '1';
          if (resources.get("1") == 0) {
            resources.put("1",1);
            coins-=2;
          }
        }
        if (mouseY >= 140 && mouseY <= 172 && (resources.get("X") > 0 || coins >= 2)) {
          selectedResource = 'X';
          if (resources.get("X") == 0) {
            resources.put("X",1);
            coins-=2;
          }
        }
        if (mouseY >= 180 && mouseY <= 212 && (resources.get("t") > 0 || coins >= 2)) {
          selectedResource = 't';
          if (resources.get("t") == 0) {
            resources.put("t",1);
            coins-=2;
          }
        }
        if (mouseY >= 220 && mouseY <= 252 && (resources.get("b") > 0 || coins >= 2)) {
          selectedResource = 'b';
          if (resources.get("b") == 0) {
            resources.put("b",1);
            coins-=2;
          }
        }
        
        if (mouseY >= 260 && mouseY <= 292 && (resources.get("e") > 0 || coins >= 3)) {
          selectedResource = 'e';
          if (resources.get("e") == 0) {
            resources.put("e",1);
            coins-=3;
          }
        }
        if (mouseY >= 300 && mouseY <= 332 && (resources.get("p") > 0 || coins >= 3)) {
          selectedResource = 'p';
          if (resources.get("p") == 0) {
            resources.put("p",1);
            coins-=3;
          }
        }
      } else if (mouseX >=width-65 && mouseX <=width-30) { //buy column
        if (mouseY >= 65 && mouseY <= 90 && coins >= 1) {
          int old2 = resources.get("2");
          coins-=1;
          resources.put("2",old2+1);
        }
        if (coins >= 2) {
          if (mouseY >= 105 && mouseY <= 130) { //1
            int old1 = resources.get("1");
            coins-=2;
            resources.put("1", old1+1);
          }
          if (mouseY >= 145 && mouseY <= 170) { //x
            int oldX = resources.get("X");
            coins-=2;
            resources.put("X",oldX+1);
          }
          if (mouseY >= 185 && mouseY <= 210) { //t
            int oldt = resources.get("t");
            coins-=2;
            resources.put("t",oldt+1);
          }
          if (mouseY >= 225 && mouseY <= 250) { //b
            int oldb = resources.get("b");
            coins-=2;
            resources.put("b",oldb+1);
          }
        }
        if (coins >= 3) { //e,p
          if (mouseY >= 265 && mouseY <= 290) { //e
            int olde = resources.get("e");
            coins-=3;
            resources.put("e",olde+1);
          }
          if (mouseY >= 305 && mouseY <= 330) { //p
            int oldp = resources.get("p");
            coins-=3;
            resources.put("p",oldp+1);
          }
        }
      }
    }
  }
  
}

void mouseReleased() {
  String oldString = "";
  if (selectedResource != ' ') {
    if (mouseX > TILE_SIZE*tileMap[0].length()) {
      selectedResource = ' ';
    } else if (tileMouseX < tileMap[0].length() && tileMouseX >= 0 && tileMouseY >= 0 && tileMouseY < tileMap.length) {
      if (selectedResource == 'X') {
        if (tileMap[tileMouseY].charAt(tileMouseX) != '0' && tileMap[tileMouseY].charAt(tileMouseX) != '2' && tileMap[tileMouseY].charAt(tileMouseX) != 'x' 
          && tileMap[tileMouseY].charAt(tileMouseX) != 'S' && tileMap[tileMouseY].charAt(tileMouseX) != 'E' && resources.get("X") > 0) {
            //explode tile
            oldString = tileMap[tileMouseY];
            if (!mute) {
            destroy.rewind();
            destroy.play();
            }
            //need to go through objects and deactivate if at the same location!
            InteractiveObject[] objectArray = objects.toArray(new InteractiveObject[0]);
              for (int i = 0; i < objectArray.length; i++) {
               if (objectArray[i].hitbox.x == tileMouseX && objectArray[i].hitbox.y == tileMouseY) {
                 objectArray[i].active = false;
               }
              }
            
            
            //need to erase bgBuffer, in case of actual type 1 tile...not actually erasing here, quick solution
            //i can't comment out the code below for some reason. the stuff afterwards doesn't work right if i do.
            bgBuffer.beginDraw();
            bgBuffer.fill(255,30,30,255);
            bgBuffer.stroke(0,0,0,0);
            bgBuffer.rect(tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE,TILE_SIZE,TILE_SIZE);
            bgBuffer.endDraw();
            
            color newColor = color(0,0,0,0);
            bgBuffer.loadPixels();
            for (int bgY = 0; bgY < 32; bgY++) {
              int startingPixel = ((tileMouseY*TILE_SIZE)+bgY)*width;
              for (int bgX = 0; bgX < 32; bgX++) {
                bgBuffer.pixels[startingPixel+bgX+(tileMouseX*TILE_SIZE)] = newColor;
              }
            }
            bgBuffer.updatePixels();
            //all this erasing above seems to be working... still don't really understand
            tileMap[tileMouseY] = oldString.substring(0,tileMouseX)+'0'+oldString.substring(tileMouseX+1);
            int oldX = resources.get("X");
            resources.put("X", oldX-1);
          }        
      } else if (tileMap[tileMouseY].charAt(tileMouseX) == '0') { //selected is not TNT
        int oldResource = resources.get(Character.toString(selectedResource));
        oldString = tileMap[tileMouseY];
         if (oldResource > 0) {
          resources.put(Character.toString(selectedResource),oldResource-1);
          if (!mute) {
          placeTile.rewind();
          placeTile.play();
          }
          switch (selectedResource) {
            case '2':
              
              tileMap[tileMouseY] = oldString.substring(0,tileMouseX)+'2'+oldString.substring(tileMouseX+1);
              
              bgBuffer.beginDraw();
              bgBuffer.image(img2,tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE);
              bgBuffer.endDraw();
              
              break;
            case '1':
              tileMap[tileMouseY] = oldString.substring(0,tileMouseX)+'1'+oldString.substring(tileMouseX+1);
              
              bgBuffer.beginDraw();
              bgBuffer.image(img1,tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE);
              bgBuffer.endDraw();
              break;
            case 't':
              tileMap[tileMouseY] = oldString.substring(0,tileMouseX)+'1'+oldString.substring(tileMouseX+1);
              objects.add(new InteractiveObject('t',new Rectangle(tileMouseX,tileMouseY,1,1)));
              break;
            case 'b':
              tileMap[tileMouseY] = oldString.substring(0,tileMouseX)+'1'+oldString.substring(tileMouseX+1);
              objects.add(new InteractiveObject('b',new Rectangle(tileMouseX,tileMouseY,1,1)));
              break;
            case 'e':
              objects.add(new InteractiveObject('e',new Rectangle(tileMouseX,tileMouseY,1,1)));
              break;
            case 'p':
              tileMap[tileMouseY] = oldString.substring(0,tileMouseX)+'1'+oldString.substring(tileMouseX+1);
              objects.add(new InteractiveObject('p',new Rectangle(tileMouseX,tileMouseY,1,1)));
              break;
          }
        }
      }
     selectedResource = ' '; 
    }
  }
}

void keyPressed() {
  if (key == 'm' || key == 'M') {
    mute = !mute;
  }
  if (key == 'r' || key == 'R') {
    loadLevel(currentLevel);
  }
  if ((key == 'n' || key == 'N') && !jumper.moving) {
    if (currentLevel+1 < levelResources.length) {
      currentLevel++;
      loadLevel(currentLevel);
    }
  }
}

void draw() {
  background(30,30,30,255);
  image(bgBuffer,0,0);
  
  
  
  
  if (levelMade && jumper.alive) {
      jumper.update();
      jumper.paint();
  }
  fill(255,255,255);
  text("Resources:", width-310,20);
  stroke(255,255,255,255);
  fill(0,0,0,0);
  rect(width-305, 35, 280, 305);
  fill(255,255,0);
  text("Coins: "+coins, width-300,50);
  fill(255,255,255);
  image(img2, width-300,60);
  text(" x"+resources.get("2")+ " (Buy more for 1 coin each)", width-270,80);
  image(img1, width-300,100);
  stroke(0,0,0,0);
  fill(100,100,100);
  rect(width-65,65,35,25);
  if (coins >= 1) {
    fill(255,255,0);
  } else {
    fill(30,30,30);
  }
  text("Buy", width-60,80);
  
  fill(255,255,255);
  text(" x"+resources.get("1")+ " (Buy more for 2 coins each)", width-270,120);
  image(tntImg, width-300,140);
  text(" x"+resources.get("X")+ " (Buy more for 2 coins each)", width-270,160);
  image(tempImg, width-300,180);
  text(" x"+resources.get("t")+ " (Buy more for 2 coins each)", width-270,200);
  image(b10, width-300, 220);
  text(" x"+resources.get("b")+ " (Buy more for 2 coins each)", width-270,240);
  
  fill(100,100,100);
  rect(width-65,105,35,25);
  rect(width-65,145,35,25);
  rect(width-65,185,35,25);
  rect(width-65,225,35,25);
  if (coins >= 2) {
    fill(255,255,0);
  } else {
    fill(30,30,30);
  }
  text("Buy", width-60, 120);
  text("Buy", width-60, 160);
  text("Buy", width-60, 200); 
  text("Buy", width-60, 240);
  
  image(enemyImg, width-300,260);
  fill(255,255,255);
  text(" x"+resources.get("e")+ " (Buy more for 3 coins each)", width-270,280);
  image(spring0, width-300,300);
  fill(255,255,255);
  text(" x"+resources.get("p")+ " (Buy more for 3 coins each)", width-270,320);
  
   fill(100,100,100);
  rect(width-65,265,35,25);
  rect(width-65,305,35,25);
  if (coins >= 3) {
    fill(255,255,0);
  } else {
    fill(30,30,30);
  }
  text("Buy", width-60, 280);
  text("Buy", width-60, 320); 
  
  fill(255,255,255);
  String muteString ="";
  if (mute) {
    muteString = " (Now muted)";
  } 
  text("Click an icon and drag it to\nthe play area to place it.\n\nPress a Buy button to get additional resources.\n\nYou can also click an icon to buy that resource,\nif you can afford it.\n\nPress R to restart the level.\n\nPress M to mute/unmute sound."+muteString, width-310,370);
  
  tileMouseX = (mouseX/TILE_SIZE);
  tileMouseY = (mouseY/TILE_SIZE);
  tint(255,255,255,175);
  if (selectedResource == ' ') {
    if (mouseX <= TILE_SIZE*tileMap[0].length()) {
      stroke(255,255,255);
      fill(0,0,0,0);
      rect(tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE, TILE_SIZE, TILE_SIZE);
    }
  } else {
    if (selectedResource == 'X') {
      if (tileMouseX < tileMap[0].length() && tileMouseY < tileMap.length && tileMouseY >= 0 && tileMouseX >= 0) {
        if (tileMap[tileMouseY].charAt(tileMouseX) != '0' && tileMap[tileMouseY].charAt(tileMouseX) != '2' && tileMap[tileMouseY].charAt(tileMouseX) != 'x' 
        && tileMap[tileMouseY].charAt(tileMouseX) != 'S' && tileMap[tileMouseY].charAt(tileMouseX) != 'E') {
          stroke(0,255,0,200);
        } else {
          stroke(255,0,0,200);
        }
      } else {
        stroke(255,0,0,200);
      }
      
      
      image(tntImg, tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE);
    } else {
      if (tileMouseX < tileMap[0].length() && tileMouseY < tileMap.length && tileMouseY >= 0 && tileMouseX >= 0) {
        if ((tileMap[tileMouseY].charAt(tileMouseX) == '0')) {
          stroke(0,255,0,200);
        } else {
          stroke(255,0,0,200);
        }
      } else {
        stroke(255,0,0,200);
      }
      switch (selectedResource) {
        case '2':
          image(img2, tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE);
          break;
        case '1':
          image(img1,tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE);
          break;
        case 't':
          image(tempImg, tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE);
          break;
        case 'b':
          image(b10, tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE);
          break;
        case 'e':
          image(enemyImg, tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE);
          break;
        case 'p':
          image(spring0, tileMouseX*TILE_SIZE,(tileMouseY*TILE_SIZE)-5);
          break;
      }
    }
  }
  fill (255,255,255,255);
  int levelStr = currentLevel+1;
  text("\n\n"+GAME_TITLE+ " (Prototype)\n\nA game by Devin Wilson for LD48 25\n(Theme: 'You Are The Villain')", width-310, height-90);
  text("Level "+levelStr, width-60, 20);
  fill(0,0,0,0);
  rect(width-64, 2, 50,25);
  rect(tileMouseX*TILE_SIZE,tileMouseY*TILE_SIZE,32,32);
  tint(255,255,255,255);
  if (!jumper.moving) {
    fill(30,30,30,255);
    stroke(255,255,255,255);
    rect(width*0.2, height*0.4, width*0.6, height*0.2);
    int levelOverTextX = int(width*0.225);
    int levelOverTextY = int(height*0.45);
    fill(255,255,255,255);
    
    if (currentLevel+1 < levelResources.length) {
      text("Good job! Press N to advance.", levelOverTextX, levelOverTextY);
    } else {
      text("Thanks for playing! You've finished all of the levels in this version of the game!\n\nPlease provide feedback to devin@devinwilson.net or @Devin_Wilson on Twitter,\nas this is a prototype for a game that the designer would like to create an enhanced\nversion of in the future, with more levels, more varied tile types, and other cool features!", levelOverTextX-8, levelOverTextY); 
    }
  }
}
